#!/bin/bash
DEPS=(
  firefox # Browser
  git # Source control system used to synchronize the common scripts (and also most projects)
  isync # IMAP4 to Maildir synchronization. Provides the mbsync program, used to sync mail for neomutt.
  khal # Command-line-based CalDAV editor
  khard # Command-line-based CardDAV editor, also used by neomutt to look up contacts
  libsecret-tools # Command-line tools for working with the DBUS Secret Service, as implemented by GNOME Keyring et al. Provides secret-tool, used by vdirsyncer to get the passwords for the CalDAV and CardDAV accounts.
  neomutt # Command-line-based mail client
  nvim # Upgraded version of vim used for editing
  tmux # Terminal multiplexer, used for persistence of shell sessions
  todoman # Text based todo manager
  vdirsyncer # CalDAV and CardDAV syncer, used to mirror contacts and calendars to the local machine for Khal and Khard/Todoman
  zsh # Alternative shell
)

sudo apt install "${DEPS[@]}"
