#compdef deno

autoload -U is-at-least

_deno() {
    typeset -A opt_args
    typeset -a _arguments_options
    local ret=1

    if is-at-least 5.2; then
        _arguments_options=(-s -S -C)
    else
        _arguments_options=(-s -C)
    fi

    local context curcontext="$curcontext" state line
    _arguments "${_arguments_options[@]}" \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
":: :_deno_commands" \
"*::: :->deno" \
&& ret=0
    case $state in
    (deno)
        words=($line[1] "${words[@]}")
        (( CURRENT += 1 ))
        curcontext="${curcontext%:*:*}:deno-command-$line[1]:"
        case $line[1] in
            (bundle)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--lock=[Check the specified lock file]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-remote[Do not resolve remote modules]' \
'--no-check[Skip type checking modules]' \
'--lock-write[Write lock file (use with --lock)]' \
'--watch[UNSTABLE: Watch for file changes and restart process automatically]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':source_file:_files' \
'::out_file:_files' \
&& ret=0
;;
(cache)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--lock=[Check the specified lock file]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-remote[Do not resolve remote modules]' \
'--no-check[Skip type checking modules]' \
'--lock-write[Write lock file (use with --lock)]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':file:_files' \
&& ret=0
;;
(compile)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--lock=[Check the specified lock file]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'--allow-read=[Allow file system read access]' \
'--allow-write=[Allow file system write access]' \
'--allow-net=[Allow network access]' \
'--unsafely-ignore-certificate-errors=[DANGER: Disables verification of TLS certificates]' \
'--allow-env=[Allow environment access]' \
'--allow-run=[Allow running subprocesses]' \
'--allow-ffi=[Allow loading dynamic libraries]' \
'--location=[Value of '\''globalThis.location'\'' used by some web APIs]' \
'--v8-flags=[Set V8 command line options (for help: --v8-flags=--help)]' \
'--seed=[Seed Math.random()]' \
'-o+[Output file (defaults to $PWD/<inferred-name>)]' \
'--output=[Output file (defaults to $PWD/<inferred-name>)]' \
'--target=[Target OS architecture]: :(x86_64-unknown-linux-gnu x86_64-pc-windows-msvc x86_64-apple-darwin aarch64-apple-darwin)' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-remote[Do not resolve remote modules]' \
'--no-check[Skip type checking modules]' \
'--lock-write[Write lock file (use with --lock)]' \
'--allow-hrtime[Allow high resolution time measurement]' \
'-A[Allow all permissions]' \
'--allow-all[Allow all permissions]' \
'--prompt[Fallback to prompt if required permission wasn'\''t passed]' \
'--cached-only[Require that remote dependencies are already cached]' \
'--enable-testing-features-do-not-use[INTERNAL: Enable internal features used during integration testing]' \
'--compat[Node compatibility mode. Currently only enables built-in node modules like '\''fs'\'' and globals like '\''process'\''.]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':script_arg -- Script arg:_files' \
&& ret=0
;;
(completions)
_arguments "${_arguments_options[@]}" \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':shell:(zsh bash fish powershell elvish)' \
&& ret=0
;;
(coverage)
_arguments "${_arguments_options[@]}" \
'--ignore=[Ignore coverage files]' \
'*--include=[Include source files in the report]' \
'*--exclude=[Exclude source files from the report]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--lcov[Output coverage report in lcov format]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':files:_files' \
&& ret=0
;;
(doc)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--json[Output documentation in JSON format]' \
'--private[Output private documentation]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
'::source_file:_files' \
'::filter -- Dot separated path to symbol:_files' \
&& ret=0
;;
(eval)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--lock=[Check the specified lock file]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'--inspect=[Activate inspector on host:port (default: 127.0.0.1:9229)]' \
'--inspect-brk=[Activate inspector on host:port and break at start of user script]' \
'--location=[Value of '\''globalThis.location'\'' used by some web APIs]' \
'--v8-flags=[Set V8 command line options (for help: --v8-flags=--help)]' \
'--seed=[Seed Math.random()]' \
'--ext=[Set standard input (stdin) content type]: :(ts tsx js jsx)' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-remote[Do not resolve remote modules]' \
'--no-check[Skip type checking modules]' \
'--lock-write[Write lock file (use with --lock)]' \
'--cached-only[Require that remote dependencies are already cached]' \
'--enable-testing-features-do-not-use[INTERNAL: Enable internal features used during integration testing]' \
'--compat[Node compatibility mode. Currently only enables built-in node modules like '\''fs'\'' and globals like '\''process'\''.]' \
'-T[Treat eval input as TypeScript]' \
'--ts[Treat eval input as TypeScript]' \
'-p[print result to stdout]' \
'--print[print result to stdout]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':code_arg -- Code arg:_files' \
&& ret=0
;;
(fmt)
_arguments "${_arguments_options[@]}" \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'--ext=[Set standard input (stdin) content type]: :(ts tsx js jsx md json jsonc)' \
'--ignore=[Ignore formatting particular source files]' \
'--options-line-width=[Define maximum line width. Defaults to 80.]' \
'--options-indent-width=[Define indentation width. Defaults to 2.]' \
'--options-prose-wrap=[Define how prose should be wrapped. Defaults to always.]: :(always never preserve)' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--check[Check if the source files are formatted]' \
'--watch[UNSTABLE: Watch for file changes and restart process automatically]' \
'--options-use-tabs[Use tabs instead of spaces for indentation. Defaults to false.]' \
'--options-single-quote[Use single quotes. Defaults to false.]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
'::files:_files' \
&& ret=0
;;
(info)
_arguments "${_arguments_options[@]}" \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'--location=[Show files used for origin bound APIs like the Web Storage API when running a script with '\''--location=<HREF>'\'']' \
'--import-map=[Load import map file]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-check[Skip type checking modules]' \
'--json[UNSTABLE: Outputs the information in JSON format]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
'::file:_files' \
&& ret=0
;;
(install)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--lock=[Check the specified lock file]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'--allow-read=[Allow file system read access]' \
'--allow-write=[Allow file system write access]' \
'--allow-net=[Allow network access]' \
'--unsafely-ignore-certificate-errors=[DANGER: Disables verification of TLS certificates]' \
'--allow-env=[Allow environment access]' \
'--allow-run=[Allow running subprocesses]' \
'--allow-ffi=[Allow loading dynamic libraries]' \
'--inspect=[Activate inspector on host:port (default: 127.0.0.1:9229)]' \
'--inspect-brk=[Activate inspector on host:port and break at start of user script]' \
'--location=[Value of '\''globalThis.location'\'' used by some web APIs]' \
'--v8-flags=[Set V8 command line options (for help: --v8-flags=--help)]' \
'--seed=[Seed Math.random()]' \
'-n+[Executable file name]' \
'--name=[Executable file name]' \
'--root=[Installation root]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-remote[Do not resolve remote modules]' \
'--no-check[Skip type checking modules]' \
'--lock-write[Write lock file (use with --lock)]' \
'--allow-hrtime[Allow high resolution time measurement]' \
'-A[Allow all permissions]' \
'--allow-all[Allow all permissions]' \
'--prompt[Fallback to prompt if required permission wasn'\''t passed]' \
'--cached-only[Require that remote dependencies are already cached]' \
'--enable-testing-features-do-not-use[INTERNAL: Enable internal features used during integration testing]' \
'--compat[Node compatibility mode. Currently only enables built-in node modules like '\''fs'\'' and globals like '\''process'\''.]' \
'-f[Forcefully overwrite existing installation]' \
'--force[Forcefully overwrite existing installation]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':cmd:_files' \
&& ret=0
;;
(uninstall)
_arguments "${_arguments_options[@]}" \
'--root=[Installation root]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':name:_files' \
&& ret=0
;;
(lsp)
_arguments "${_arguments_options[@]}" \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
&& ret=0
;;
(lint)
_arguments "${_arguments_options[@]}" \
'(--rules)--rules-tags=[Use set of rules with a tag]' \
'(--rules)--rules-include=[Include lint rules]' \
'(--rules)--rules-exclude=[Exclude lint rules]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'--ignore=[Ignore linting particular source files]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--rules[List available rules]' \
'--json[Output lint result in JSON format]' \
'--watch[UNSTABLE: Watch for file changes and restart process automatically]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
'::files:_files' \
&& ret=0
;;
(repl)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--lock=[Check the specified lock file]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'--inspect=[Activate inspector on host:port (default: 127.0.0.1:9229)]' \
'--inspect-brk=[Activate inspector on host:port and break at start of user script]' \
'--location=[Value of '\''globalThis.location'\'' used by some web APIs]' \
'--v8-flags=[Set V8 command line options (for help: --v8-flags=--help)]' \
'--seed=[Seed Math.random()]' \
'--eval=[Evaluates the provided code when the REPL starts.]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-remote[Do not resolve remote modules]' \
'--no-check[Skip type checking modules]' \
'--lock-write[Write lock file (use with --lock)]' \
'--cached-only[Require that remote dependencies are already cached]' \
'--enable-testing-features-do-not-use[INTERNAL: Enable internal features used during integration testing]' \
'--compat[Node compatibility mode. Currently only enables built-in node modules like '\''fs'\'' and globals like '\''process'\''.]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
&& ret=0
;;
(run)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--lock=[Check the specified lock file]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'--allow-read=[Allow file system read access]' \
'--allow-write=[Allow file system write access]' \
'--allow-net=[Allow network access]' \
'--unsafely-ignore-certificate-errors=[DANGER: Disables verification of TLS certificates]' \
'--allow-env=[Allow environment access]' \
'--allow-run=[Allow running subprocesses]' \
'--allow-ffi=[Allow loading dynamic libraries]' \
'--inspect=[Activate inspector on host:port (default: 127.0.0.1:9229)]' \
'--inspect-brk=[Activate inspector on host:port and break at start of user script]' \
'--location=[Value of '\''globalThis.location'\'' used by some web APIs]' \
'--v8-flags=[Set V8 command line options (for help: --v8-flags=--help)]' \
'--seed=[Seed Math.random()]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-remote[Do not resolve remote modules]' \
'--no-check[Skip type checking modules]' \
'--lock-write[Write lock file (use with --lock)]' \
'--allow-hrtime[Allow high resolution time measurement]' \
'-A[Allow all permissions]' \
'--allow-all[Allow all permissions]' \
'--prompt[Fallback to prompt if required permission wasn'\''t passed]' \
'--cached-only[Require that remote dependencies are already cached]' \
'--enable-testing-features-do-not-use[INTERNAL: Enable internal features used during integration testing]' \
'--compat[Node compatibility mode. Currently only enables built-in node modules like '\''fs'\'' and globals like '\''process'\''.]' \
'(--inspect --inspect-brk)--watch[UNSTABLE: Watch for file changes and restart process automatically]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
':script_arg -- Script arg:_files' \
&& ret=0
;;
(test)
_arguments "${_arguments_options[@]}" \
'--import-map=[Load import map file]' \
'-c+[Load configuration file]' \
'--config=[Load configuration file]' \
'-r+[Reload source code cache (recompile TypeScript)]' \
'--reload=[Reload source code cache (recompile TypeScript)]' \
'--lock=[Check the specified lock file]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'--allow-read=[Allow file system read access]' \
'--allow-write=[Allow file system write access]' \
'--allow-net=[Allow network access]' \
'--unsafely-ignore-certificate-errors=[DANGER: Disables verification of TLS certificates]' \
'--allow-env=[Allow environment access]' \
'--allow-run=[Allow running subprocesses]' \
'--allow-ffi=[Allow loading dynamic libraries]' \
'--inspect=[Activate inspector on host:port (default: 127.0.0.1:9229)]' \
'--inspect-brk=[Activate inspector on host:port and break at start of user script]' \
'--location=[Value of '\''globalThis.location'\'' used by some web APIs]' \
'--v8-flags=[Set V8 command line options (for help: --v8-flags=--help)]' \
'--seed=[Seed Math.random()]' \
'--ignore=[Ignore files]' \
'--fail-fast=[Stop after N errors. Defaults to stopping after first failure.]' \
'--filter=[Run tests with this string or pattern in the test name]' \
'--shuffle=[(UNSTABLE): Shuffle the order in which the tests are run]' \
'(--inspect --inspect-brk)--coverage=[UNSTABLE: Collect coverage profile data into DIR]' \
'-j+[Number of parallel workers, defaults to # of CPUs when no value is provided. Defaults to 1 when the option is not present.]' \
'--jobs=[Number of parallel workers, defaults to # of CPUs when no value is provided. Defaults to 1 when the option is not present.]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--no-remote[Do not resolve remote modules]' \
'--no-check[Skip type checking modules]' \
'--lock-write[Write lock file (use with --lock)]' \
'--allow-hrtime[Allow high resolution time measurement]' \
'-A[Allow all permissions]' \
'--allow-all[Allow all permissions]' \
'--prompt[Fallback to prompt if required permission wasn'\''t passed]' \
'--cached-only[Require that remote dependencies are already cached]' \
'--enable-testing-features-do-not-use[INTERNAL: Enable internal features used during integration testing]' \
'--compat[Node compatibility mode. Currently only enables built-in node modules like '\''fs'\'' and globals like '\''process'\''.]' \
'--no-run[Cache test modules, but don'\''t run tests]' \
'--doc[UNSTABLE: type check code blocks]' \
'--allow-none[Don'\''t return error code if no test files are found]' \
'(--no-run --coverage)--watch[UNSTABLE: Watch for file changes and restart process automatically]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
'::files -- List of file names to run:_files' \
'::script_arg -- Script arg:_files' \
&& ret=0
;;
(types)
_arguments "${_arguments_options[@]}" \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
&& ret=0
;;
(upgrade)
_arguments "${_arguments_options[@]}" \
'--version=[The version to upgrade to]' \
'--output=[The path to output the updated version to]' \
'--cert=[Load certificate authority from PEM encoded file]' \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'--dry-run[Perform all checks without replacing old exe]' \
'-f[Replace current exe even if not out-of-date]' \
'--force[Replace current exe even if not out-of-date]' \
'--canary[Upgrade to canary builds]' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
&& ret=0
;;
(help)
_arguments "${_arguments_options[@]}" \
'-L+[Set log level]: :(debug info)' \
'--log-level=[Set log level]: :(debug info)' \
'-h[Prints help information]' \
'--help[Prints help information]' \
'-V[Prints version information]' \
'--version[Prints version information]' \
'--unstable[Enable unstable features and APIs]' \
'-q[Suppress diagnostic output]' \
'--quiet[Suppress diagnostic output]' \
&& ret=0
;;
        esac
    ;;
esac
}

(( $+functions[_deno_commands] )) ||
_deno_commands() {
    local commands; commands=(
        "bundle:Bundle module and dependencies into single file" \
"cache:Cache the dependencies" \
"compile:UNSTABLE: Compile the script into a self contained executable" \
"completions:Generate shell completions" \
"coverage:Print coverage reports" \
"doc:Show documentation for a module" \
"eval:Eval script" \
"fmt:Format source files" \
"info:Show info about cache or info related to source file" \
"install:Install script as an executable" \
"uninstall:Uninstall a script previously installed with deno install" \
"lsp:Start the language server" \
"lint:Lint source files" \
"repl:Read Eval Print Loop" \
"run:Run a JavaScript or TypeScript program" \
"test:Run tests" \
"types:Print runtime TypeScript declarations" \
"upgrade:Upgrade deno executable to given version" \
"help:Prints this message or the help of the given subcommand(s)" \
    )
    _describe -t commands 'deno commands' commands "$@"
}
(( $+functions[_deno__bundle_commands] )) ||
_deno__bundle_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno bundle commands' commands "$@"
}
(( $+functions[_deno__cache_commands] )) ||
_deno__cache_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno cache commands' commands "$@"
}
(( $+functions[_deno__compile_commands] )) ||
_deno__compile_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno compile commands' commands "$@"
}
(( $+functions[_deno__completions_commands] )) ||
_deno__completions_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno completions commands' commands "$@"
}
(( $+functions[_deno__coverage_commands] )) ||
_deno__coverage_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno coverage commands' commands "$@"
}
(( $+functions[_deno__doc_commands] )) ||
_deno__doc_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno doc commands' commands "$@"
}
(( $+functions[_deno__eval_commands] )) ||
_deno__eval_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno eval commands' commands "$@"
}
(( $+functions[_deno__fmt_commands] )) ||
_deno__fmt_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno fmt commands' commands "$@"
}
(( $+functions[_deno__help_commands] )) ||
_deno__help_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno help commands' commands "$@"
}
(( $+functions[_deno__info_commands] )) ||
_deno__info_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno info commands' commands "$@"
}
(( $+functions[_deno__install_commands] )) ||
_deno__install_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno install commands' commands "$@"
}
(( $+functions[_deno__lint_commands] )) ||
_deno__lint_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno lint commands' commands "$@"
}
(( $+functions[_deno__lsp_commands] )) ||
_deno__lsp_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno lsp commands' commands "$@"
}
(( $+functions[_deno__repl_commands] )) ||
_deno__repl_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno repl commands' commands "$@"
}
(( $+functions[_deno__run_commands] )) ||
_deno__run_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno run commands' commands "$@"
}
(( $+functions[_deno__test_commands] )) ||
_deno__test_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno test commands' commands "$@"
}
(( $+functions[_deno__types_commands] )) ||
_deno__types_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno types commands' commands "$@"
}
(( $+functions[_deno__uninstall_commands] )) ||
_deno__uninstall_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno uninstall commands' commands "$@"
}
(( $+functions[_deno__upgrade_commands] )) ||
_deno__upgrade_commands() {
    local commands; commands=(
        
    )
    _describe -t commands 'deno upgrade commands' commands "$@"
}

_deno "$@"